#include "board.h"
#include "twoPlayers.h"
#include "randomAI.h"
#include "smartAI.h"

int main(int argc, char **argv){
    if(argc != 4){
        printf("Usage: puissance4 <mode> <row> <col>\n");
        printf("mode ");
        printf("specifies the mode: 1 = single player game (random),\n     2 = single player game (AI), 3 = two players game\n");
        printf("row   specifies the number of rows (>= 4)\n");
        printf("col   specifies the number of columns (>= 4)\n");
    }
    else{
        srand(0); // seed for random
    
        struct board board = create_board(atoi(argv[3]), atoi(argv[2]));
        init_board(&board);
        printf("Board size is %dx%d (rows x col)\n", board.line, board.col);
        print_game(&board);
        switch (atoi(argv[1])) // Select a game mode between randomAI, smartAI or two players
        {
            case 1:
                play_with_randomAI(board);
                break;
            case 2:
                play_with_smartAI(board);
                break;
            case 3:
                play_two_players(board);
                break;
        }
        free_board(&board);
    }
    return EXIT_SUCCESS;
}