#include "randomAI.h"

/**
 * Actions for play with a random AI
 * @param struct the game board
 * @return no return
 */
void play_with_randomAI(struct board board){
    int no_col = 0; 
    int no_line = 0;
    int no_round = 1;

    while(!is_full_board(board)){ // While the board is not full
        if(no_round % 2 != 0){ // For the player and the random AI play alternating
            printf("Column number? (starts at 1):");
            scanf("%d", &no_col);
            printf("\n");

            no_line = current_line(board,no_col - 1);
            board.data[no_line][no_col - 1] = Croix; // Put the player's piece (Cross) in the board
            board.last_symbole = Croix;
        }
        else{
            no_col = rand() % 7 + 1;
            no_line = current_line(board,no_col - 1);
            board.data[no_line][no_col - 1] = Cercle; // Put the random AI's (Circle) piece in the board
            board.last_symbole = Cercle;
        }

        board.last_pos_x = no_line;
        board.last_pos_y = no_col - 1;

        print_game(&board);

        if(winner(board)){ // Check if there is a winner after each placement of a piece
            if(board.last_symbole == Croix){
                printf("Player one won!\n");
            }
            else if(board.last_symbole == Cercle){
                printf("Computer won!\n");
            }
            break;
        }

        no_round++; // Increment no_round for the next round
    }
    if(is_full_board(board)){
        printf("It is a draw.\n");
    }
}
