#include "winnerCheck.h"

/**
 * Check if there is a row of four 
 * @param struct the pointer of the game board
 * @return retrurn true if there is a row of four, false if there is anything
 */
bool row_of_four(struct board *board){
    for (int col = 0; col < board->col - 3; col++) {
        if (board->data[board->last_pos_x][col] != Vide && 
            board->data[board->last_pos_x][col] == board->data[board->last_pos_x][col+1] && 
            board->data[board->last_pos_x][col] == board->data[board->last_pos_x][col+2] && 
            board->data[board->last_pos_x][col] == board->data[board->last_pos_x][col+3]) {
            return true; 
        }
    }
    return false;
}

/**
 * Check if there is a colunm of four 
 * @param struct the pointer of the game board
 * @return retrurn true if there is a colunm of four, false if there is anything
 */
bool col_of_four(struct board *board){
    for (int row = 0; row < board->line - 3; row++) {
        if (board->data[row][board->last_pos_y] != Vide && 
            board->data[row][board->last_pos_y] == board->data[row+1][board->last_pos_y] && 
            board->data[row][board->last_pos_y] == board->data[row+2][board->last_pos_y] && 
            board->data[row][board->last_pos_y] == board->data[row+3][board->last_pos_y]) {
            return true; 
        }
    }
    return false;
}

/**
 * Check if there is a diagonal from left to right of four 
 * @param struct the pointer of the game board
 * @return retrurn true if there is a diagonal of four, false if there is anything
 */
bool diag_of_four_left_right(struct board *board){
    for (int row = 0; row < board->line - 3; row++) {
        for (int col = 0; col < board->col - 3; col++) {
            if (board->data[row][col] != Vide && 
                board->data[row][col] == board->data[row+1][col+1] && 
                board->data[row][col] == board->data[row+2][col+2] && 
                board->data[row][col] == board->data[row+3][col+3]) {
                return true; 
            }
        }
    }
    return false;
}

/**
 * Check if there is a diagonal from right to left of four 
 * @param struct the pointer of the game board
 * @return retrurn true if there is a diagonal of four, false if there is anything
 */
bool diag_of_four_right_left(struct board *board){
    for (int row = 0; row < board->line - 3; row++) {
        for (int col = 3; col < board->col; col++) {
            if (board->data[row][col] != Vide && 
                board->data[row][col] == board->data[row+1][col-1] && 
                board->data[row][col] == board->data[row+2][col-2] && 
                board->data[row][col] == board->data[row+3][col-3]) {
                return true;
            }
        }
    }
    return false;
}

/**
 * Check if the function above is true
 * @param struct the game board
 * @return return true is one of function is true, false if all function are false
 */
bool winner(struct board board){
    return row_of_four(&board) || diag_of_four_left_right(&board) || diag_of_four_right_left(&board) || col_of_four(&board);
}